/*****************************************************************************
 *
 * Atmel Corporation
 *
 * ̧		: XMLParser.hpp
 * ߲	: Dev-C++ 4.9.8.0 - http://bloodshed.net/dev/
 * 		: $Revision: 3419 $
 * t		: $Date: 2008N222 09:56:34 +0100 $
 * XV	: $Author: khole $
 *
 * xҰ	: avr@atmel.com
 *
 * ړI	: Win32
 *
 * pLq	: AVR911 - AVRJ݊
 *
 * 		: ȒPXML DOMl͕̉BXMĻق犮SȖ؍\\z
 *			  B<section/>ނx܂Aޑ͎x܂B
 *
 ****************************************************************************/

#ifndef XMLPARSER_HPP
#define XMLPARSER_HPP

using namespace std;

#include "ErrorMsg.hpp"
#include "Utility.hpp"
#include <iostream>
#include <fstream>
#include <list>

class XMLAbstractNode;						// b`
class XMLTree;
class XMLNode;

/* XMĻ ׽BҿނXML؍\Ŝ܂݂܂B */
class XMLFile
{
	protected:
		XMLTree * root;							// ؍\܂͒ʏ(ɰ)ǂ炩̍(ٰ ɰ)

		void XMLFile::removeStartXML( string & txt );	// JnXMLގ苎
		void removeComments( string & txt );	// ގ苎
		void removeAttributes( string & txt );	// ނ瑮苎
		void readFile( const string & _filename );	// XMĻٓǂݍ
		void parseFragment( string & fragment, XMLTree * parent );

	public:
		/* ݽ׸ */
		XMLFile( const string & _filename );

		/* ޽׸ */
		~XMLFile();

		/* ҿ */
		bool exists( const string & path );				// (ɰ)
		const string & getValue( const string & path );	// (ɰ)l擾

		void print();
};

#endif
